# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::EventGrid::Mgmt::V2020_04_01_preview
  module Models
    #
    # Properties of a partner topic type.
    #
    class PartnerTopicType < Resource

      include MsRestAzure

      # @return [String] Official name of the partner.
      attr_accessor :partner_name

      # @return [String] Name of the partner topic type. This name should be
      # unique among all partner topic types names.
      attr_accessor :topic_type_name

      # @return [String] Display Name for the partner topic type.
      attr_accessor :display_name

      # @return [String] Description of the partner topic type.
      attr_accessor :description

      # @return [String] URI of the partner website that can be used by Azure
      # customers to setup Event Grid
      # integration on an event source.
      attr_accessor :setup_uri

      # @return [PartnerTopicTypeAuthorizationState] Status of whether the
      # customer has authorized a partner to create partner topics
      # in the customer's subscription. Possible values include:
      # 'NotApplicable', 'NotAuthorized', 'Authorized'
      attr_accessor :authorization_state


      #
      # Mapper for PartnerTopicType class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'PartnerTopicType',
          type: {
            name: 'Composite',
            class_name: 'PartnerTopicType',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              partner_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.partnerName',
                type: {
                  name: 'String'
                }
              },
              topic_type_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.topicTypeName',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.displayName',
                type: {
                  name: 'String'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.description',
                type: {
                  name: 'String'
                }
              },
              setup_uri: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.setupUri',
                type: {
                  name: 'String'
                }
              },
              authorization_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.authorizationState',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
