# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::EventGrid::Mgmt::V2020_10_15_preview
  module Models
    #
    # Information about the azure function destination for an event
    # subscription.
    #
    class AzureFunctionEventSubscriptionDestination < EventSubscriptionDestination

      include MsRestAzure


      def initialize
        @endpointType = "AzureFunction"
      end

      attr_accessor :endpointType

      # @return [String] The Azure Resource Id that represents the endpoint of
      # the Azure Function destination of an event subscription.
      attr_accessor :resource_id

      # @return [Integer] Maximum number of events per batch. Default value: 1
      # .
      attr_accessor :max_events_per_batch

      # @return [Integer] Preferred batch size in Kilobytes. Default value: 64
      # .
      attr_accessor :preferred_batch_size_in_kilobytes

      # @return [Array<DeliveryAttributeMapping>] Delivery attribute details.
      attr_accessor :delivery_attribute_mappings


      #
      # Mapper for AzureFunctionEventSubscriptionDestination class as Ruby
      # Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AzureFunction',
          type: {
            name: 'Composite',
            class_name: 'AzureFunctionEventSubscriptionDestination',
            model_properties: {
              endpointType: {
                client_side_validation: true,
                required: true,
                serialized_name: 'endpointType',
                type: {
                  name: 'String'
                }
              },
              resource_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.resourceId',
                type: {
                  name: 'String'
                }
              },
              max_events_per_batch: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.maxEventsPerBatch',
                default_value: 1,
                type: {
                  name: 'Number'
                }
              },
              preferred_batch_size_in_kilobytes: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.preferredBatchSizeInKilobytes',
                default_value: 64,
                type: {
                  name: 'Number'
                }
              },
              delivery_attribute_mappings: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.deliveryAttributeMappings',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'DeliveryAttributeMappingElementType',
                      type: {
                        name: 'Composite',
                        polymorphic_discriminator: 'type',
                        uber_parent: 'DeliveryAttributeMapping',
                        class_name: 'DeliveryAttributeMapping'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
