# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::EventGrid::Mgmt::V2020_10_15_preview
  module Models
    #
    # Information about the webhook destination for an event subscription.
    #
    class WebHookEventSubscriptionDestination < EventSubscriptionDestination

      include MsRestAzure


      def initialize
        @endpointType = "WebHook"
      end

      attr_accessor :endpointType

      # @return [String] The URL that represents the endpoint of the
      # destination of an event subscription.
      attr_accessor :endpoint_url

      # @return [String] The base URL that represents the endpoint of the
      # destination of an event subscription.
      attr_accessor :endpoint_base_url

      # @return [Integer] Maximum number of events per batch. Default value: 1
      # .
      attr_accessor :max_events_per_batch

      # @return [Integer] Preferred batch size in Kilobytes. Default value: 64
      # .
      attr_accessor :preferred_batch_size_in_kilobytes

      # @return [String] The Azure Active Directory Tenant ID to get the access
      # token that will be included as the bearer token in delivery requests.
      attr_accessor :azure_active_directory_tenant_id

      # @return [String] The Azure Active Directory Application ID or URI to
      # get the access token that will be included as the bearer token in
      # delivery requests.
      attr_accessor :azure_active_directory_application_id_or_uri

      # @return [Array<DeliveryAttributeMapping>] Delivery attribute details.
      attr_accessor :delivery_attribute_mappings


      #
      # Mapper for WebHookEventSubscriptionDestination class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'WebHook',
          type: {
            name: 'Composite',
            class_name: 'WebHookEventSubscriptionDestination',
            model_properties: {
              endpointType: {
                client_side_validation: true,
                required: true,
                serialized_name: 'endpointType',
                type: {
                  name: 'String'
                }
              },
              endpoint_url: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.endpointUrl',
                type: {
                  name: 'String'
                }
              },
              endpoint_base_url: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.endpointBaseUrl',
                type: {
                  name: 'String'
                }
              },
              max_events_per_batch: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.maxEventsPerBatch',
                default_value: 1,
                type: {
                  name: 'Number'
                }
              },
              preferred_batch_size_in_kilobytes: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.preferredBatchSizeInKilobytes',
                default_value: 64,
                type: {
                  name: 'Number'
                }
              },
              azure_active_directory_tenant_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.azureActiveDirectoryTenantId',
                type: {
                  name: 'String'
                }
              },
              azure_active_directory_application_id_or_uri: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.azureActiveDirectoryApplicationIdOrUri',
                type: {
                  name: 'String'
                }
              },
              delivery_attribute_mappings: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.deliveryAttributeMappings',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'DeliveryAttributeMappingElementType',
                      type: {
                        name: 'Composite',
                        polymorphic_discriminator: 'type',
                        uber_parent: 'DeliveryAttributeMapping',
                        class_name: 'DeliveryAttributeMapping'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
